﻿// <summary>ソースコード：モデル共通定義クラス</summary>
// <author>CommonMP</author>

using System;
using System.Collections.Generic;
using System.Text;

using CommonMP.HYSSOP.Interface.HSData;
using CommonMP.HYSSOP.CoreImpl.HSData;
using CommonMP.HYSSOP.CoreImpl.HSTools;

namespace jp.or.jccajsce.UnitGraph
{
    /// <summary><para>class outline:</para>
    /// <para>モデル共通定義クラス</para>
    /// </summary>
    /// <remarks>
    /// <para>Remarks:</para>
    /// <para>本クラスは、必須ではないが、使用の便利さの為、常数等の定義を一つに纏めておく</para>
    /// <para>history:</para>
    /// <para>[CommonMP][ver 1.0.0][2008/10/01][新規作成]</para>
    /// </remarks>
    public class UnitGraphDefine
    {
        
        //********************************
        //===== ファクトリ関連定義 ========
        //********************************
        /// <summary>ライブラリを識別するためのユニークID</summary>
        public static HySID M_LIB = new HySID("jp.or.jccajsce.UnitGraph_Factory");

        //********************************
        //===== モデル関連定義 ========
        //********************************
        /// <summary>モデル種別を識別するためのユニークID</summary>
        public static readonly HySObjectKind M_KIND = new HySObjectKind("jp.or.jccajsce.UnitGraph_Model");
        /// <summary>モデル名称</summary>
        public static readonly HySString M_NAME = new HySString(Properties.Resources.STRING_MODEL_NAME);

        //********************************
        //===== 受信パターンを識別するためのユニークID ========
        //********************************
        //HACK:
        //  pattern will be sorted by Hashtable.Keys;
        //  at present, the ascending order of HySID("hashcode_*") would be
        //dre3HuWr, cRe7ubre, febRe2EF, zawEp2ur, V5KEfuxu, 
        //v8wRuSte, pan5DesE, F7uCewer, WrUwe3uv, huqAh2Pr, 
        //c6nUspur, guv4SWaV, chur4spU, qA6ufemu, CuthUnE3, 
        //stUHe7tA, gaquyu4U, Frew7aSW, C2Etheca, c7puKusw
        // (these strings are randomly generated)
        
        /// <summary>降雨量, point</summary>
        public static readonly HySID IN_RAINFALL_POINT_PTN = new HySID("dre3HuWr"); //prioprity 1
        /// <summary>降雨量, 1D</summary>
        public static readonly HySID IN_RAINFALL_1D_PTN = new HySID("cRe7ubre"); //prioprity 2
        /// <summary>流量, point</summary>
        public static readonly HySID OUT_DISCHARGE_POINT_PTN = new HySID("febRe2EF"); //prioprity 3
        /// <summary>流量, 1D</summary>
        public static readonly HySID OUT_DISCHARGE_1D_PTN = new HySID("zawEp2ur"); //prioprity 4

    }
}
